<!-- 收货地址编辑 添加收货地址-->
<template>
  <div>
    <div class="row flex flex-m " :class="{'dot':!validate.name}">
      <div>收货人：</div>
      <input v-fixedInput class="row_input flex-1" v-model="formData.name" type="text" placeholder="请输入收货人">
    </div>
    <div class="row flex flex-m" :class="{'dot':!validate.mobile}">
      <div>联系电话：</div>
      <input v-fixedInput class="row_input flex-1" v-model="formData.mobile"  type="text" placeholder="请输入联系电话">
    </div>
    <div class="row flex flex-m" @click="checkAddress" :class="{'dot':!validate.addressLable}">
      <div>所在地区：</div>
      <div class="flex flex-m flex-b flex-1">
        <div class="row_location--name">{{addressLable | addressLable}}</div>
        <van-icon name="arrow" />
      </div>
    </div>
    <van-field
      class="flex-1"
      :class="{'dot':!validate.address}"
      label="团购批量输入:"
      arrow-direction="down"
      v-model="formData.address"
      type="textarea"
      placeholder="电话|名字|详细地址"
      rows="1"
      autosize
    />
     
     <div class="chencBox">
       <van-checkbox v-model="formData.is_default" class="m_checkbox--quare m_checkbox--quare2 flex flex-m" checked-color="#4C80C1">设为默认</van-checkbox>
     </div>
     
    <div class="btn_add" @click="submit">保存</div>


    <!-- 选择地区 -->
    <div>
      <van-popup v-model="show" position="bottom" >
        <van-area v-if="show" :value="addressValue+''" :area-list="areaList" :columns-num="3" title="" @confirm="handelConfirm" @cancel="handelCancel" />
     </van-popup>
    </div>
  </div>
</template>

<script>
import area from '../../utils/area.js'
export default {
  name:'addAddress',
  props:['that'],
  data() {
    return {
      show:false,
      address_status:'', //add为添加地址 edit为编辑地址
      areaList:area,
      addressValue:'',
      addressLable:'',
      formData:{
        
       name:'',//收货人
       mobile:'', //电话
       address:'', //详细地址
       province:'',
       city:'',
       area:'',
       code:'',
       tag:'',
       is_default:false,
       
     
       
       
       //beDefault:false //设为默认地址，0否1是
      },
    }
  },

  computed:{
    validate(){
      let name = this.Validate_null(this.formData.name)
      let mobile = this.Validate_tell(this.formData.mobile)
      let address = this.Validate_null(this.formData.address)
      console.log(this.formData.address);
      
      let addressLable = this.Validate_null(this.addressLable)

      return {
        name,mobile,address,addressLable,
        flag:name&&mobile&&address&&addressLable
      }
    
    }
  },
  mounted(){
   this.init()
  },
  methods:{
    init(){
     this.changeTitle()
    },
    
    //判断空
    Validate_null(v){
      return !!v
    },

    //判断手机
    Validate_tell(v){
       v = v +''
       return (v[0]==1)&&(v.length==11)
    },


    

    //保存
    submit(){
      // if(!this.validate.flag){
      //   this.m_toast('请完整填写信息')
      //   return   
      // }
      let apiKey = this.address_status=='edit'?'address_update':'address_add'
      let msg = this.address_status=='edit'?'修改成功':'添加成功'
      let formData = this._dep(this.formData)
      formData.is_default =  formData.is_default?'1':'0'
      this.m_loading()
      this.api[apiKey](formData).then(res=>{
        this.m_hideLoading()
        this.m_success(msg)
        //this.$router.go(-1)
        this.that.AddAddressShow = false
        this.that.getDeliveryAddressList()
      })

    },
    

   
    

    //改变标题地址
    changeTitle(){
       let address_status = sessionStorage.address_status 
       if(!address_status){
         sessionStorage.address_status ='add'
         address_status="add"
       }else{
         if(address_status=='add'){
           this.sePageTitle('新增收货地址')
         }else{
           this.sePageTitle('编辑收货地址')
            this.fillData()
         }
       }
       this.address_status = address_status
    },

    //编辑时 填充数据
    fillData(){
     let addressInfo = JSON.parse(sessionStorage.addressInfo);
     //sessionStorage.addressInfo = ''
     this.formData = this.coverEditData(this.formData,addressInfo)
     this.formData.is_default = this.formData.is_default ==1
     this.addressValue = this.formData.city
     this.formData.id = addressInfo.id
     this.addressLable = `${this.province(this.formData.province)}/${this.city(this.formData.city)}`
     


    },

     province(v){
          let List = area.province_list
          return List[v]
      },

      city(v){
          let List = area.city_list
          return List[v]
      },
   
   //弹出选择地址框
    checkAddress(){
      this.show = true
    },
   
   //确认选择地址
    handelConfirm(arr){
      this.addressLable = arr.map(i=>i.name).join('/')
      this.formData.province = arr[0].code
      this.formData.city = arr[1].code
       this.formData.area = arr[2].code
      this.addressValue = arr.concat().reverse()[0].code
      this.show = false
      console.log(arr)
    },

    //取消选择地址
    handelCancel(arr){
      this.show = false
    }

  },
  watch:{
    //限制输入长度
    'formData.mobile'(v){
      if((v+'').length>=11){
       this.formData.mobile = v.slice(0,11)
      }
    }
  },
  filters:{
    addressLable(v){
      if(!v){
        return '请选择所在地区'
      }
      return v
    }
  }
  
}

</script>
<style scoped>
.row {
    height: 1.10rem;
    background-color: #fff;
    line-height: 1.10rem;
    font-size: .30rem;
    color: #444;
    padding-left: .26rem;
    padding-right: .31rem;
    box-sizing: border-box;
}

.row_input {
    margin-left: .16rem;
    height: 1.10rem;
    color: #747474;
    line-height: 1.10rem;
}
.row_autoresize {
    margin-left: .16rem;
    height: auto;
    color: #747474;
    line-height: 1.10rem;
}
.row_location--name {
    margin-left: .16rem;
    /* width: 5.00rem; */
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    color: #747474;
}
.row_location--icon {
    width: .18rem;
    height: .28rem;
    padding-left: .05rem;
    padding-right: .05rem;
}

.btn_add {
    position: fixed;
    bottom: .80rem;
    left: 50%;
    transform: translateX(-50%);
    width: 6.28rem;
    height: .88rem;
    line-height: .88rem;
    background-color: #4C80C1;
    border-radius: 14px;
    font-size: .30rem;
    color: #fff;
    text-align: center;
}
.chencBox{
  margin-top: .32rem;
  margin-left: .26rem;
  font-size: .28rem;
  color: #444444;

}
</style>